import org.junit.Test;
import static org.junit.Assert.*;

public class LifeTest {
    
    @Test
    public void createNewCell() {
        
        // Arrange: drei lebende Zellen
        Life l = new Life();
        l.setAlive(0, 0);
        l.setAlive(0, 1);
        l.setAlive(0, 2);

        // Act: Berechnung der Folgegeneration
        ILife nextGen = l.nextGeneration();

        // Assert: Rasterpunkt mit drei Nachbarn sollte jetzt leben
        assertTrue(nextGen.isAlive(1, 1));
    }


    @Test
    public void destroyLonelyCell() {
        //Arrange: eine lebende Zelle
        Life l = new Life();
        l.setAlive(1, 1);

        //Act
        ILife nextGen = l.nextGeneration();

        //Assert: Zelle sollte jetzt tot sein
        assertFalse(nextGen.isAlive(1,1));
    }


    @Test
    public void keepAliveCell() {
        // Arrange: drei lebende Zellen
        Life l = new Life();
        l.setAlive(0, 0);
        l.setAlive(0, 1);
        l.setAlive(1, 0);

        // Act: Berechnung der Folgegeneration
        ILife nextGen = l.nextGeneration();

        // Assert: Rasterpunkt mit zwei Nachbarn lebt noch
        assertTrue(nextGen.isAlive(0, 1));
    }


    @Test
    public void destroyCrowdedCell() {
        // Arrange: Zellblock
        Life l = new Life();
        l.setAlive(0, 0);
        l.setAlive(0, 1);
        l.setAlive(0, 2);
        l.setAlive(1, 0);
        l.setAlive(1, 1);

        // Act: Berechnung der Folgegeneration
        ILife nextGen = l.nextGeneration();

        // Assert: Rasterpunkt mit vier Nachbarn ist tot
        assertFalse(nextGen.isAlive(1, 1));
    }


}
